// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <SetIni.h> // include class containing initializations for MC
using namespace std;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_getpipe(){

    extern SetIni inival;

// get seed from time
    time_t curtime=time(NULL);      // get current time
    struct tm *tmp = localtime(&curtime);
//  cout << tmp->tm_min << tmp->tm_sec << tmp->tm_mday << tmp->tm_mon << tmp->tm_hour << tmp->tm_min << endl;
    char dat1[20],dat2[20],dat3[20],dat4[20],dat5[20];
    sprintf(dat1, "%i", tmp->tm_mon);
    sprintf(dat2, "%i", tmp->tm_mday);
    sprintf(dat3, "%i", tmp->tm_hour);
    sprintf(dat4, "%i", tmp->tm_min);
    sprintf(dat5, "%i", tmp->tm_sec);

    char outpupipes[201];
    strncpy(outpupipes,"pipe_", 200);
    strncat(outpupipes, "m", 1 );
    strncat(outpupipes, dat1, strlen(dat1) );
    strncat(outpupipes, "_d", 2 );
    strncat(outpupipes, dat2, strlen(dat2) );
    strncat(outpupipes, "_h", 2 );
    strncat(outpupipes, dat3, strlen(dat3) );
    strncat(outpupipes, "_m", 2 );
    strncat(outpupipes, dat4, strlen(dat4) );
    strncat(outpupipes, "_s", 2 );
    strncat(outpupipes, dat5, strlen(dat5) );
    inival.PipeName = new char[strlen(outpupipes)+1];  
    strcpy(inival.PipeName,outpupipes);

   }

