// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
// loading initial file 
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCvlabel.h>
#include <WSCmessageDialog.h>  
#include <WSClist.h>
#include <WSCvtimer.h> 
#include <WSCdialog.h>
#include <WSCtform.h>
#include <SetIni.h> // include class containin initialisation
#include <sys/stat.h>
using namespace std; 

extern char * RUNDIR;

extern WSCvtimer* newvtim_001;
extern WSClist* newlist_000;  
extern WSCmessageDialog* newmess_000;
extern WSCmessageDialog* newmess_001;
extern WSCvlabel* newvlab_017;
extern WSCvlabel* newvlab_049;
extern WSCdialog* newdial_005;
extern WSCtform* newtfor_002;
extern WSCvlabel* newvlab_040;
extern WSCvlabel* newvlab_041;
extern WSCvlabel* newvlab_035;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_showcomment() {
  //do something...
 char buffer[256];
 WSCstring USERlines[50];
 WSCstring USERcomment;
 WSCstring USERstop=" \n"; 
 int iuu=0; 
// char * RUNDIR=getenv("RUNMC");
 char getcomment[700];
 struct stat buf;

   extern SetIni inival; 
// show message dialog
   newvlab_041->setPropertyV(WSNlabelString, inival.MOutput );

// look at comment file:
   strcpy(getcomment,RUNDIR);
   strncat(getcomment, "/proj/user-comment.txt", strlen("/proj/user-comment.txt")); 
   int icom = stat ( getcomment, &buf); 
  if (icom != 0) {
  newvlab_040->setPropertyV(WSNlabelString,"comments from file \"user-comment.txt\" \n are not available"); 
  } else {

  ifstream commentfile(getcomment);
  if (! commentfile.is_open())
  { newmess_001->setPropertyV(WSNlabelString,"Cannot read user-comment.txt file!"); 
    newmess_001->popup( ); }
  while (! commentfile.eof() )
  {
    commentfile.getline(buffer,100);
//    cout << buffer << endl;
    iuu++; 
    USERlines[iuu]=buffer; 
    USERcomment=USERcomment+USERlines[iuu]; 
    USERcomment=USERcomment+USERstop; 
  }
  newvlab_040->setPropertyV(WSNlabelString,(char*)USERcomment);
  } // end if 

//  newdial_005->setPropertyV(WSNvis,(WSCbool)1);
  long result=newdial_005->popup();
  if (result == WS_DIALOG_OK){
   // 
  }else
  if (result == WS_DIALOG_NO){
    //NO button is pressed.
  }else
  if (result == WS_DIALOG_CANCEL){
     newlist_000->update(); // update just to be sure 
  };  



}
