#!/bin/bash
 
MYDIR=`pwd`
# shared libraries 
DIRLIB=$RUNMC"/build-win32/ws/lib"

# prepare Windows installations
cp -f $RUNMC"/main/gui/runmc_gui.cpp-win32" $RUNMC"/main/gui/runmc_gui.cpp"
cp -f $RUNMC"/main/gui/notepad_runmc/notepad.cpp-win32"  $RUNMC"/main/gui/notepad_runmc/notepad.cpp"



# ###################################
NAME="runmc_gui.exe" 
BINNAME=$RUNMC"/bin/runmc_gui.exe"


# if exists - done 
if [ ! -f "$BINNAME" ]
then
    echo "--> shared libraries in $DIRLIB"
    make -f Makefile-win32 
    pid=$!;  wait $pid;
    mv -f $NAME  $BINNAME
else
    echo "RUNMC GUI \"runmc_gui.exe\" already exists"
fi


NAME1="notepad_runmc.exe"
BINNAME1=$RUNMC"/bin/notepad_runmc.exe"
# notepad
if [ ! -f "$BINNAME1" ]
then
    echo "--> shared libraries in $DIRLIB"
    cd $RUNMC/main/gui/notepad_runmc;  
    make -f Makefile-win32;
    pid=$!;  wait $pid;
    mv -f $NAME1 $BINNAME1 
else
    echo "RUNMC notepad exists"
fi



cd $MYDIR
echo " "
exit 0
