#!/bin/bash
 
MYDIR=`pwd`
# shared libraries 
DIRLIB=$RUNMC"/lib/"


# prepare linux installations
cp -f $RUNMC"/main/gui/runmc_gui.cpp-linux" $RUNMC"/main/gui/runmc_gui.cpp"
cp -f $RUNMC"/main/gui/notepad_runmc/notepad.cpp-linux"  $RUNMC"/main/gui/notepad_runmc/notepad.cpp"



# ###################################
NAME="runmc_gui" 
BINNAME=$RUNMC"/bin/runmc_gui"


# if exists - done 
if [ ! -f "$BINNAME" ]
then
    echo "--> shared libraries in $DIRLIB"
    make -f Makefile-linux 
    pid=$!;  wait $pid;
    mv -f $NAME  $BINNAME
else
    echo "RUNMC GUI \"runmc_gui\" already exists"
fi


NAME1="notepad_runmc"
BINNAME1=$RUNMC"/bin/notepad_runmc"
# notepad
if [ ! -f "$BINNAME1" ]
then
    echo "--> shared libraries in $DIRLIB"
    cd $RUNMC/main/gui/notepad_runmc;  make -f Makefile-linux;
    pid=$!;  wait $pid;
    mv -f $NAME1 $BINNAME1 
else
    echo "RUNMC notepad exists"
fi



cd $MYDIR
echo " "
exit 0
