// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSDappDev.h>
 
//--- OBJECT includes ---//
#include <WSCtextField.h>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <WSCstring.h>
#include <WSCsheet.h>


#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
using namespace std;

extern WSCtextField* stetext_005;
extern WSCsheet* steshee_001;
extern int decomment ( char file_in_name[], char file_out_name[], char comment[] );
extern char * namecard; 
extern int MaxParSteer;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
int steerread ()  {
// loop over all real  

  steshee_001->clear();
 

  char buffer[201];
  int NTnumber=0;
  int  NTcomm=0;
  int  nt=0;
  char * LineText[500];
  char * LineComments[400];
  WSCstring Comments = "";
  WSCstring SName[500];
  WSCstring Ind1[500];
  WSCstring Ind2[500];
  WSCstring Svalue[500];
  WSCstring Scomme[500];
  WSCstring LookComm;

  char bb[201];   char * bbs[500]; 
  char test0[60]; char * tes0[500]; 
  char test1[60]; char * tes1[500]; 
  char test2[60]; char * tes2[500]; 
  char test3[60]; char * tes3[500]; 


// get ntuples
     FILE *lss = fopen(namecard,"r");
// get comments ... 
     while ( !feof(lss) ) {
     fgets(buffer,200,lss);
     LineText[NTnumber] = new char[strlen(buffer)+1];
     strcpy(LineText[NTnumber],buffer);
//     cout << buffer << endl;
// put comments somewere
     if ( buffer[0]  == '*')  {
     LineComments[NTcomm] = new char[strlen(buffer)+1]; 
     strcpy(LineComments[NTcomm],buffer); 

     LookComm=LineComments[NTcomm];
     LookComm.delHeadSpace();
     LookComm.deleteChar(0);
     LookComm.delHeadSpace(); 

//     Comments.addString( "\n" );
     Comments.addString( (char*)LookComm  );
     NTcomm++;
     }  
     NTnumber++;
     }
     fclose(lss); 

// decomment
     int irun=decomment(namecard,"steer1.tmp","*");
     irun=decomment("steer1.tmp","steer.tmp","END$");

// get importnat lines .. 
     FILE *lsss = fopen("steer.tmp","r"); 
     while ( !feof(lsss) )  {  
//   cout <<  buffer;
//   if (buffer[0] != '*' && strcmp(buff[nt],"END$") != 0  )  {
     fscanf(lsss,"%s %s %s %s", test0,test1,test2,test3); fgets(bb,200,lsss);
//   cout << test0 << test1 << test2 << test3 << bb << endl; 

     tes0[nt] = new char[strlen(test0)+1];
     strcpy(tes0[nt],test0);
     tes1[nt] = new char[strlen(test1)+1];
     strcpy(tes1[nt],test1);
     tes2[nt] = new char[strlen(test2)+1];
     strcpy(tes2[nt],test2);
     tes3[nt] = new char[strlen(test3)+1];
     strcpy(tes3[nt],test3);
     bbs[nt] = new char[strlen(bb)+1];
     strcpy(bbs[nt],bb);

     SName[nt]=tes0[nt];
     SName[nt].deleteChar(0);
     long Nchars=SName[nt].getChars();
     SName[nt].deleteChar(Nchars-1);
 
     Ind1[nt]=tes1[nt];  
     Ind2[nt]=tes2[nt];
     Svalue[nt]=tes3[nt];
     Scomme[nt]=bbs[nt];
     Scomme[nt].delLineFeed();
     Scomme[nt].delHeadSpace();
     Scomme[nt].deleteChar(0);
     Scomme[nt].delHeadSpace();
     nt++;     
     }
     fclose(lsss);

    stetext_005->setProperty(WSNlabelString,(char*)Comments); 
    remove ("steer1.tmp"); 
    remove ("steer.tmp");

// edit table 
  steshee_001->setPropertyV(WSNrows,(long)MaxParSteer);
  steshee_001->setPropertyV(WSNcols,(long)6);
  steshee_001->setText(1, 1, "Parameter");
  steshee_001->setText(2, 1, "Index I");
  steshee_001->setText(3, 1, "Index II");
  steshee_001->setText(4, 1, "Value");
  steshee_001->setText(5, 1, "Comment");

  steshee_001->setCellLock(1,1,(WSCbool)1);
  steshee_001->setCellLock(2,1,(WSCbool)1);
  steshee_001->setCellLock(3,1,(WSCbool)1);
  steshee_001->setCellLock(4,1,(WSCbool)1);
  steshee_001->setCellLock(5,1,(WSCbool)1);
// put yellow staff
  for (int i=2; i<=MaxParSteer; i++) {
  steshee_001->setCellBkColor(5, i, "#ffffcc");
  steshee_001->setCellAlignemnt(1,i,WS_CENTER);
  steshee_001->setCellAlignemnt(2,i,WS_CENTER);
  steshee_001->setCellAlignemnt(3,i,WS_CENTER);
  steshee_001->setCellAlignemnt(4,i,WS_CENTER);
  steshee_001->setCellAlignemnt(5,i,WS_LEFT);
  }

// titles 
  steshee_001->setCellAlignemnt(1,1,WS_CENTER);
  steshee_001->setCellAlignemnt(2,1,WS_CENTER);
  steshee_001->setCellAlignemnt(3,1,WS_CENTER);
  steshee_001->setCellAlignemnt(4,1,WS_CENTER);
  steshee_001->setCellAlignemnt(5,1,WS_LEFT);


// put colors on defintions ..
   char * labcil="DEF1";
   steshee_001->setCellBkColor(1, 1, labcil);
   steshee_001->setCellBkColor(2, 1, labcil);
   steshee_001->setCellBkColor(3, 1, labcil);
   steshee_001->setCellBkColor(4, 1, labcil);
   steshee_001->setCellBkColor(5, 1, labcil);
   steshee_001->setFocusCell(1, 2);

// set values
    for (int i=0; i<nt-1; i++) {
    steshee_001->setText(1, i+2, (char*)SName[i]  );
    steshee_001->setText(2, i+2, (char*)Ind1[i]  );
    steshee_001->setText(3, i+2, (char*)Ind2[i]  );
    steshee_001->setText(4, i+2, (char*)Svalue[i]  );
    steshee_001->setText(5, i+2, (char*)Scomme[i]  );
    }


   return 0;

}
