
package JRunMC;

// utility variables 
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.plaf.*;
import java.io.*;
import java.math.*;
import java.util.Calendar;  

   public class  Utility {
     

 //------------ auxilary function- get pipe variables 
      public static String GetPipe() {
       
        String tmp=null;
          Calendar now = Calendar.getInstance();
                      int mo=now.get(Calendar.MONTH);
                      int d = now.get(Calendar.DAY_OF_MONTH);   
                      int h = now.get(Calendar.HOUR_OF_DAY);
                      int m = now.get(Calendar.MINUTE);
                      int s = now.get(Calendar.SECOND);
        
     tmp=Integer.toString(mo)+"m_"+Integer.toString(d)+"d_"+ Integer.toString(h)+"h_";
     tmp=tmp+Integer.toString(h)+"h_"+Integer.toString(m)+"m_"+Integer.toString(s);
      
       return "pipe_"+tmp;
               
      }
// ----    
     
     
//------------ auxilary function- get integers from strings      
      public static int GetInt(String s) {
       
        int  nn=0;        
        try { 
           nn=Integer.parseInt(s.trim());        
         }
         catch (NumberFormatException e) {
        // System.out.println("Error in reading integer from "+s);
        //  JOptionPane dialogError = new JOptionPane();
        //  dialogError.showMessageDialog(dialogError,"Error in reading integer from "+s,"Error",
        //  JOptionPane.ERROR_MESSAGE);
         }  
         return nn;  }
// ---------------------------------------      
     

//------------ auxilary function- get integers from strings
// -- with error check 
        public static int GetIntError(String s) {
        int  nn=0;
        try {
           nn=Integer.parseInt(s.trim());
         }
         catch (NumberFormatException e) {
         // System.out.println("Error in reading integer from "+s);
         JOptionPane dialogError = new JOptionPane();
         dialogError.showMessageDialog(dialogError,"Error in reading integer from "+s,"Error",
         JOptionPane.ERROR_MESSAGE);
         }
         return nn;  }

 
      
 //------------ auxilary function- get double from strings      
       public  static double GetDouble(String s) {
        double dd=0.0;
        try { dd=Double.parseDouble(s.trim()); }
        catch (NumberFormatException e) {
       //  JOptionPane dialogError = new JOptionPane();
       //  dialogError.showMessageDialog(dialogError,"Error in reading Double from "+s,"Error",
       //  JOptionPane.ERROR_MESSAGE);
       //System.out.println("Error in reading double from "+s);
        }  return dd;  }
// ---------------------------------------      
           
//------------ auxilary function- get double from strings
// - with error check      
       public  static double GetDoubleError(String s) {
        double dd=0.0;
        try { dd=Double.parseDouble(s.trim()); }
        catch (NumberFormatException e) {
         JOptionPane dialogError = new JOptionPane();
         dialogError.showMessageDialog(dialogError,"Error in reading Double from "+s,"Error",
         JOptionPane.ERROR_MESSAGE);
        }  return dd;  }

//------------ auxilary function- id of state in combor box      
      public static int GetID(int n) {
        int ii=0;
        if (n==-11)    ii=0;
        if (n== 11)    ii=1;
        if (n== 2212)  ii=2;
        if (n== -2212) ii=3;
        if (n== 2112)  ii=4;
        if (n== -2112) ii=5;
        if (n==   22)  ii=6;
        if (n==   13)  ii=7;
        if (n==  -13)  ii=8;
        return ii;  }
// ---------------------------------------      
         
 
//------------ auxilary function- id of state in combor box      
      public static int GetIDhep(int n) {
        int ii=0;
        if (n==0)    ii=-11;
        if (n==1)    ii=11;
        if (n== 2)  ii=2212;
        if (n== 3)  ii=-2212;
        if (n== 4)  ii=2112;
        if (n== 5)  ii=-2112;
        if (n== 6)  ii=22;
        if (n== 7)  ii=13;
        if (n== 8)  ii=-13;
        return ii;  }
// ---------------------------------------           
      
      
 //------------ auxilary function- id of state in combor box      
      
      // get string to run particular model
      public static String runjob(int n) {
    
      String s1="echo Error To start the run"; 
      if (n>0) {    
        int dis=iDIS();   
        String s2=" 1> "+SetIni.MOutput+".log 2> "+SetIni.MOutput+".err &"; 
        s1=SetIni.exeMC[n]+s2;
        // redo for DIS for ariadne
        if (n == 3 && dis==1) s1="analmc.lepto-ariadne"+s2;
      }   

     if (n<0) {
        File inF = new File(".analmc.tup");
        if (inF.exists()) {  
         s1="analmc.pythia6 1> "+SetIni.MOutput+".log 2> "+SetIni.MOutput+".err &";
        } else {
         JOptionPane dialogError = new JOptionPane();
         dialogError.showMessageDialog(dialogError,"Error in reading file .analmc.tup","Error",
         JOptionPane.ERROR_MESSAGE);
        }; 
     }
// run ntuples 

 
   //   System.out.println(dis);
   //   System.out.println(n);
   //   System.out.println(s1);
      return s1;
      
    }
// ---------------------------------------            
      // return 1 if this is DIS
     public static int iDIS(){
        
    int itmp=0;   
      
    if ( SetIni.Q2min > 1.) {
    if ( Math.abs(SetIni.IDparticle1) < 17 && Math.abs(SetIni.IDparticle2) > 2000 )  itmp=1;
    if ( Math.abs(SetIni.IDparticle2) < 17 && Math.abs(SetIni.IDparticle1) > 2000 )  itmp=1; }

     return itmp;
      
    }
// ---------------------------------------       
 
      // return 1 if this is lepton-lepto 
     public static int iEE(){
 
    int itmp=0;
    if ( Math.abs(SetIni.IDparticle1) < 17 && Math.abs(SetIni.IDparticle2) < 17 )  itmp=1;
    if ( Math.abs(SetIni.IDparticle2) < 17 && Math.abs(SetIni.IDparticle1) < 17 )  itmp=1; 
 
     return itmp;
 
    }
// ---------------------------------------
    
     // return 1 if this is pp etc 
     public static int iPP(){
 
    int itmp=0;
    if ( Math.abs(SetIni.IDparticle1) >2000 && Math.abs(SetIni.IDparticle2) >2000 )  itmp=1;
    if ( Math.abs(SetIni.IDparticle2) >2000 && Math.abs(SetIni.IDparticle1) >2000 )  itmp=1; 
 
     return itmp;
 
    }


// check for errors
    public static String runmcError(){ 

    String itmp="";

    int tmp=0;
// EE collisions 
    if ( Math.abs(SetIni.IDparticle1) < 17 && Math.abs(SetIni.IDparticle2) < 17 )  tmp=1;
    if ( Math.abs(SetIni.IDparticle2) < 17 && Math.abs(SetIni.IDparticle1) < 17 )  tmp=1;
    if (tmp == 1 && (SetIni.MCtype >  3 && SetIni.MCtype < 9) )  {
           itmp="Lepton-Lepton collisions are not implemented \n for this Monte Carlo model"; 
           return itmp;
    }

// PP collisions  
    if ( Math.abs(SetIni.IDparticle1) > 2000 && Math.abs(SetIni.IDparticle2) > 2000  )  tmp=1;
    if ( Math.abs(SetIni.IDparticle2) > 2000 && Math.abs(SetIni.IDparticle1) > 2000  )  tmp=1;
    if (tmp == 1 && (SetIni.MCtype ==  4 || 
                     SetIni.MCtype ==  5 || 
                     SetIni.MCtype ==  7 ||
                     SetIni.MCtype ==  8)   )  {  
           itmp="NN collisions are not implemented \n for this Monte Carlo model";
           return itmp;
    } 

 // the PeG
   if (SetIni.MCtype == 9) {
     itmp="This is demo ThePEG version, not implemented"; 
     return itmp;
   }


   // check histogram definitions ------------------------------------------
    String ierr_mess="";
    int ierr=0;

    for  (int i=1; i<=SetIni.HistoN; i++ ) {
    if (SetIni.HistoType[i]  > 0 ) {
    if (SetIni.HistoMax[i] <=SetIni.HistoMin[i]) {
    ierr=1; ierr_mess = "Histogram MIN value is \n larger than MAX value"; };
    if (SetIni.HistoBins[i]<=0) { ierr=1; ierr_mess = "Number of bins is wrong !"; };
    }; };
 
// first 2
    if (SetIni.Histo2D[1] == 2 && SetIni.Histo2D[2] == 2) {
    for  (int i=1; i<=2; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
    ierr=1; ierr_mess = "Error in 2D histogram definition (No 1)"; }; }; };
// second  2
    if (SetIni.Histo2D[3] == 2 && SetIni.Histo2D[4] == 2) {
    for  (int i=3; i<=4; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 2)"; }; }; };
// third  2
    if (SetIni.Histo2D[5] == 2 && SetIni.Histo2D[6] == 2) {
    for  (int i=5; i<=6; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 3)"; }; }; };
// forth  2
    if (SetIni.Histo2D[7] == 2 && SetIni.Histo2D[8] == 2) {
    for  (int i=7; i<=8; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 4)"; }; }; };


     if (ierr>0) {
           itmp=ierr_mess;
           return itmp;
     }

    return itmp;


    } // end errors 



 
   
   } // end classs 

                  
                  
 
