C this is replacement of steer subroutine from CASCADE
C to include local settings 
      SUBROUTINE RUNMCcascadesteer

      include "../inc/pythia62.inc"
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"

      include "cascade/include/casparas.inc"
      include "cascade/include/casluco.inc"
      include "cascade/include/caspara5.inc"
      include "cascade/include/caspart.inc"
      include "cascade/include/casvalues.inc"
      include "cascade/include/casshwr.inc"
      include "cascade/include/casprkt.inc"
      include "cascade/include/casscal.inc"
      include "cascade/include/casglu.inc"
      include "cascade/include/casmult.inc"

      Integer nloop,nmax
      Parameter (nmax=1000)
      character *4   para
      Real Rval
      Integer Ival,Ld,Le
      Common/steering/Nloop,Ld(nmax),Le(nmax),Ival(nmax),
     & para(nmax),Rval(nmax)
       Integer Nevent
       Common/steer1/Nevent


        write(6,*) 
     + "RUNMC: simulation of the steering subroutine in CASCADE"  
        write(6,*)
     + "RUNMC: RUNMC GUI will change your steering values"
        write(6,*)
     + "RUNMC: this may give inconsistent steering values"
        write(6,*)
     + "RUNMC: better use steering card cascade.cards !"

C       set to big number
       NEVENT = 500000000


C  number of settings in pseudocar
       Nloop=9

       do i=1,Nloop
       Ival(i) = -9999
       Rval(i) = -9999.
       Ld(i)=1
       Le(i)=0
       enddo



C set energies and ID
      para(1)='PBE1'
      Rval(1)=ENER1
      para(2)='PBE2'
      Rval(2)=-1*ENER2

      para(3)='KBE1'
      Ival(3)=PID1 
      para(4)='KBE2'
      Ival(4)=PID2

* min Q2
       para(5)='QMIN'
       Rval(5)=rQ2(2)
** max Q2
       para(6)='QMAX'
       Rval(6)=rQ2(3)

* min Y
       para(7)='YMIN'
       Rval(7)=rYbj(2)
** max Y
       para(8)='YMAX'
       Rval(8)=rYbj(3)

** max Y
       para(9)='IGLU'
       Ival(9)=1 


** Xbj not set
*      CKIN(65)=rXbj(2)
*      CKIN(66)=rXbj(3)
*   find out - is this DIS mode ?

        iEP=0
        if( (abs(PID1).le.17) .and. (abs(PID2).gt.2000) ) iEP=1
        if( (abs(PID2).le.17) .and. (abs(PID1).gt.2000) ) iEP=1

** PDF is not set

       END
