#!/bin/bash

echo "Starting install.sh for linux:"

 
MYDIR=`pwd`
DIRLOG=$MYDIR"/log/"
DIRLIB=$MYDIR"/lib/"

echo "--> libraries in $DIRLIB"
echo "--> installation log in $DIRLIB"

touch *;
touch */*;
touch */*/*;

###############################
# special traetment of realine
NAME="readline"
MYLIBMC=$DIRLIB"lib"$NAME".a"
if [ ! -f "lib/libreadline.a" ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library  libreadline.a  does not exist -> create new library"
  echo "#### Please wait...installing \"libreadline.a\" ";
cd "util/"$NAME; 
touch *; touch */*; 
     if [ -f "Makefile" ]
     then
     make clean; make distclean;
     fi; 
configure > $DIRLOG$NAME"config.log" 2>&1; 
make > $DIRLOG$NAME"make.log" 2>&1;
cd $MYDIR
mv -f util/readline/libreadline.a lib/libreadline.a
else
  echo "Library  \$RUNMC/main/mcarlo/lib/libreadline.a      exists"
fi
########################



# ###################################
NAME="pythia-6" 
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log"; 
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd $NAME; rm -f src/*.o;  
  ./split.sh 1;
  make lib > $MYLOG 2>&1; pid=$!;  wait $pid;   
  cd $MYDIR
else 
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a  exists" 
fi  
###############################

# ###################################
NAME="pythia-57"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd $NAME; rm -f src/*.o;
  ./split.sh 1;
  make lib > $MYLOG 2>&1; pid=$!;  wait $pid;
  cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a  exists" 
fi
###############################


# ###################################
NAME="jetset-74"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd $NAME; rm -f src/*.o;
  ./split.sh 1;
  make lib > $MYLOG 2>&1; pid=$!;  wait $pid;
  cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a  exists"
fi
###############################


# ###################################
NAME="phojet"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd $NAME; rm -f src/*.o;
  ./split.sh 1;
  make lib > $MYLOG 2>&1; pid=$!;  wait $pid;
  cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a  exists"
fi
###############################




# ###################################
NAME="lepto-65"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd $NAME; rm -f src/*.o;
  ./split.sh 1;
  make lib > $MYLOG 2>&1; pid=$!;  wait $pid;
  cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a   exists"
fi
###############################




#####################################
NAME="herwig-65"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file  \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd $NAME; rm -f src/*.o;
  ./split.sh 1;
  make lib > $MYLOG 2>&1;
  pid=$!;  wait $pid;
  cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a  exists" 
fi
###############################


###############################
# special traetment of ARIADNE
NAME="ariadne-412"
MYLIBMC=$DIRLIB"lib"$NAME".a"
if [ ! -f "lib/libar-4.a" ]
then
MYLOG=$DIRLOG$NAME".log";
  echo "Library      lib/libar-4.a  does not exist -> create new library"
  echo "Installing   lib/libar-4.a   -> log file  \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"libar-4.a\" ";
cd $NAME; rm -f src/*.o; rm -f src/*/*.o;  
cp -f src/arposf.f_linux src/arposf.f;
cp -f src/P6/arposf.f_linux src/P6/arposf.f; 
make > $MYLOG 2>&1;
cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/libar-4.a       exists"
fi 

if [ ! -f "lib/libar-4p5.a" ]
then
MYLOG=$DIRLOG$NAME".log";
  echo "Library      lib/libar-4p5.a  does not exist -> create new library"
  echo "Installing   lib/libar-4p5.a   -> log file  \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing  \"libar-4p5.a\" ";
cd $NAME; rm -f src/*.o; rm -f src/*/*.o;  make > $MYLOG 2>&1;
cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/libar-4p5.a     exists"
fi
################################################ 


# ###################################
# prepare cascade
NAME="bases51"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd "cascade-12/bases51"; rm -f *.o;
  make > $MYLOG 2>&1; pid=$!;  wait $pid;
  cd $MYDIR
  mv -f cascade-12/bases51/libbases51.a lib/libbases51.a 
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a   exists"
fi
###############################


# ###################################
# prepare cascade
NAME="cascade-12"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd "cascade-12/cascade"; rm -f */*.o;
  make lib > $MYLOG 2>&1; pid=$!;  wait $pid;
  cd $MYDIR
  mv -f cascade-12/cascade/lib/libcascade-12.a lib/libcascade-12.a
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a   exists"
fi
###############################



# ###################################
# prepare rapgap 
NAME="rapgap-3"
MYLIBMC=$DIRLIB"lib"$NAME".a"
cd $MYDIR;
if [ ! -f $MYLIBMC ]
then
  MYLOG=$DIRLOG$NAME".log";
  rm -f $MYLOG;
  echo "Library    \"lib$NAME.a\" does not exist -> create new library"
  echo "Installing \"lib$NAME.a\"  -> log file \$RUNMC/main/mcarlo/log/$NAME.log"
  echo "#### Please wait...installing \"lib$NAME.a\" ";
  cd "rapgap-3/"; make clean;
  make > $MYLOG 2>&1; pid=$!;  wait $pid;
  cd $MYDIR
else
  echo "Library  \$RUNMC/main/mcarlo/lib/lib$NAME.a   exists"
fi
###############################



 

# ------------------------  check for errors

cd $DIRLOG; 

for filename in *.log
# Traverse list of files ending with 1st argument.
do
# get errors
MYERRORS=`grep -i "error" $filename`;
# grep -i error *.log; MYERRORS=`grep -i -v  error *.log`;
if [ -n "$MYERRORS" ]   
then
  echo "checking $filename  -> "
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" 
  echo "There were errors in copilation of the Monte Carlo libraries"
  echo "check $DIRLOG$filename" 
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  exit 0; 
else 
  echo "checking $filename  ->  looks ok";  
fi  

done 

cd $MYDIR
echo "All libraries are done"  
echo " "

exit 0
