// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
// get all calculated value into the histogram
using namespace std;
#include<iostream>
#include<heplist.h>
#include<stdlib.h>
#include<stdio.h>

extern heplist hep;      // get particles after the cuts


// ----------------------- Fill stable hadrons 
void PrintList() {

// print list of particles for this event


// fill histgrams for each particles
  cout << " " << endl;
  cout << "New event with  " << hep.PP.size() << " particles" << endl;
  cout << " No    Id      Px       Py       Pz      E    Charge" << endl;   
  for  (unsigned int nn=0; nn < hep.PP.size(); nn++ ) {         // run over all particles
  printf("%3d %5d %8.2f %8.2f %8.3f %8.3f %3d\n",nn,hep.PP[nn].id,hep.PP[nn].p.px(),
  hep.PP[nn].p.py(),hep.PP[nn].p.pz(),hep.PP[nn].p.e(),hep.PP[nn].charge3/3);
  } // end loop over all particles

}
