// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <stdio.h>

#include <SetHisto.h> // initialization of histograms
// #include <iostream.h>

// define global variables
SetHisto inihis;

// set initial values in constructer
SetHisto::SetHisto() {
      HistoN=0; HistoNcurrent=0;  
      HistoNcurrent1D=0; HistoNcurrent2D=0;
      HistoOptions[0]=1; HistoOptions[1]=1; 
      HistoOptions[2]=1; HistoOptions[3]=600; HistoOptions[4]=400; 
      HistoOptions[5]=1; HistoOptions[6]=1; HistoOptions[7]=1; 
      HistoOptions[8]=1;  // options : events, norm events, X-sec (pb) X-sec (nb)
      HistoOptions[9]=1;  // ouput file is root histogram (1) or none (0) 
      HistoOptions[10]=0; // ouput file is HEPEVT ntuple (1) or none (0) 
      HistoOptions[11]=0; // ouput file is RUNMC  ntuple (1) or none (0) 
      HistoOptions[12]=1; // option for 2D histograms 
      for (int i=0; i<=500; i++) {
       HistoType[i]=0; Histo2D[i]=1; HistoMax[i]=0.; HistoMin[i]=0.; HistoBins[i]=0;
       HistoWeight[i]=1.;  HistoName[i]="", HistoComm[i]="";
      }; 
      }; 
