// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <iostream>
#include <WSCoption.h>
#include <SetIni.h> // include class containing initializations for M
using namespace std;

extern  void show_DIS_on_GUI();
extern  WSCoption* newopti_032;
extern  WSCoption* newopti_005;

struct Pname {int pid; char * name;};
// struct Pname PIDname1[] = { { 0, "not set"}, { 11, "e-"}, { -11, "e+"}, { 2212, "p"}, { -2212, "pbar"},
//                           { 2112, "n"}, { 22, "gamma"}, { -13, "mu-"}, { 13, "mu+"} };
struct Pname PIDname2[] = { { 0, "not set"}, { -11, "e+"}, { 11, "e-"}, { -2212, "pbar"}, { 2212, "pbar"},
                            { 2112, "n"}, { 22, "gamma"}, { 13, "mu+"}, { -13, "mu-"} };


//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_particle2(WSCbase* object){
  //do something...
    long  v = object->getProperty(WSNvalue);
    extern SetIni inival;
    inival.IDparticle2 = PIDname2[v].pid;

//    cout << inival.IDparticle2  << endl;

   if (abs(inival.IDparticle2)  < 23) {
   newopti_005->setVisible(False); // remove PDF option for electron etc 
   }else { 
   newopti_005->setVisible(True); // set for other 
   };  

// change GUI
   show_DIS_on_GUI();

}
static WSCfunctionRegister  op("ep_particle2",(void*)ep_particle2);
