// loading initial file 
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
// #include <cstdlib>
#include <sys/stat.h>
using namespace std;

#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCvlabel.h>
#include <WSCtextField.h>
#include <WSCvtimer.h>
#include <WSCstring.h>

extern WSCtextField* newtext_001;
extern WSCstring backup;
extern WSCvtimer* newvtim_001;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_readfile(WSCbase* object){
  //do something...
static long cnt = 0;
static struct stat buf;
static int inifile=-99;
// static long old_line_number=0;  
static int old_size=0;
static char * RUNDIR;
static WSCstring maindir;
static WSCstring mainproj;
static char * NameFile; 
static char buff[100];
static int ncoun=0;
static WSCstring* str;
static WSCstring maintext; 
static long lines=0;
 
  cnt++;

//  cout << cnt << endl;

  if (cnt == 1) {
// check make file
//  put info on current file name
    RUNDIR=getenv("RUNMC");
    maindir=RUNDIR;
    mainproj=maindir+"/main/tmp/project.tmp";
//    cout << mainproj << endl;
    ifstream myin(mainproj, ios::in);
    if (!myin) { 
     strcpy(buff,"analmc.log");  
     cout << "Notepad: No input file is found!" << endl;
    } else { myin >> buff; }
     myin.close();

//  NameFile.addString(".log");
    NameFile = new char[strlen(buff)+1]; strcpy(NameFile,buff); 
    strncat(NameFile, ".log",4);
//    cout << NameFile << endl;
// put label
    newtext_001->setProperty(WSNuserString,NameFile);
    }



// check file 
  inifile = stat ( NameFile, &buf ); 

  if (cnt > 0 && inifile == 0 ) {



// first read file at the very beginning 
      if (ncoun == 0) { 
      str = WSGFreadTextFile(NameFile);
      maintext=str->getString();
      lines=str->getLines(); // get number of lines
      newtext_001->setProperty(WSNlabelString,(char*)maintext);
      newtext_001->setBottomLine(lines+1);
      backup = maintext;
      newtext_001->update();
      ncoun++;
      old_size=buf.st_size;
      }



// get file size 
      int file_size=buf.st_size;
      int readsize=file_size-old_size;

// update only if this file is growing (more than 1 line) 
      if ( readsize > 10  && ncoun > 0) {

//      cout << "Should read " << readsize << endl;
//      char ch;
      char buffer[101];
      WSCstring tmp(""); long nn=0; 
// open in binary mode, read from old position 
      ifstream inlog(NameFile,ios::in | ios::binary);
      if (!inlog) cout << "Error in reading long file!" << endl;  
      inlog.seekg(old_size, ios::beg);
//     while (!inlog.eof() ) { inlog.get(ch); cout << ch; }
      while (!inlog.eof() ) { 
             inlog.getline(buffer,100); 
             if (nn>0)tmp.addString("\n"); 
             tmp.addString(buffer); 
             nn++; } //tmp.addString("\n");}
      inlog.close();

// update 
//      lines=lines+tmp.getLines(); // get number of lines
      newtext_001->addString(tmp);
//      newtext_001->setBottomLine(lines+1);
      maintext.addString(tmp); 
      backup = maintext;
      newtext_001->update();
      tmp.clear();

// set old file
      old_size=file_size; 

      }
 
   } else {  
//    printf (".analmc.log not found, cannot read it!"); };
//    newvtim_001->setProperty(WSNrunning,False); // do not run

    };  

}
static WSCfunctionRegister  op("ep_readfile",(void*)ep_readfile);
