// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <iostream>

#include <WSCoption.h>
#include <WSCvifield.h>
#include <WSCvlabel.h>

// #include <SetIni.h> // include class containing MC initializations
using namespace std;

extern WSCoption* newopti_030;
extern WSCoption* newopti_032;
extern WSCvlabel* newvlab_043;
extern WSCvlabel* newvlab_044;
extern WSCvlabel* newvlab_011;
extern WSCvlabel* newvlab_010;
extern WSCvlabel* newvlab_012;
extern WSCvlabel* newvlab_013;
extern WSCvlabel* newvlab_014;
extern WSCvlabel* newvlab_015;
extern WSCvlabel* newvlab_002;
extern WSCvlabel* newvlab_007;
extern WSCvifield* newvifi_032;
extern WSCvifield* newvifi_030;
extern WSCvifield* newvifi_003;
extern WSCvifield* newvifi_000;
extern WSCvifield* newvifi_001;
extern WSCvifield* newvifi_004;
extern WSCvifield* newvifi_007;  
extern WSCvifield* newvifi_006;
extern WSCvifield* newvifi_009; 
extern WSCvifield* newvifi_008;
 
/*
e- : newopti_030
e+ : newopti_032
250: newvifi_032
250: label newvlab_043
250: newvifi_030
250: label newvlab_044
min label: newvlab_011
max label: newvlab_010
Q2 label:  newvlab_012
Q2: newvifi_003
Q2: newvifi_000
X label: newvlab_013
         newvifi_001
         newvifi_004
Y label: newvlab_014
         newvifi_007
         newvifi_006
 
W label: newvlab_015
        newvifi_009
       newvifi_008
 
xxx.xx labels: newvlab_002
               newvlab_007
*/

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void remove_DIS_on_GUI(){
  //do something...

//   extern SetIni inival;


    newvlab_002->setVisible(False);
    newvlab_007->setVisible(False);
    newvlab_011->setVisible(False);
    newvlab_010->setVisible(False);
    newvlab_012->setVisible(False);
    newvlab_013->setVisible(False);
    newvlab_014->setVisible(False);
    newvlab_015->setVisible(False);
 
    newvifi_000->setVisible(False);
    newvifi_001->setVisible(False);
    newvifi_003->setVisible(False);
    newvifi_004->setVisible(False); 
    newvifi_006->setVisible(False);
    newvifi_007->setVisible(False);
    newvifi_008->setVisible(False);
    newvifi_009->setVisible(False);
   
}
