// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCbase.h>
#include <WSCstring.h>

#include <iostream>
#include <fstream>

using namespace std;

// for Windows, this replaces the stundard
// input file for histogram with windows-like
// this helps to put icons on the list 

void titels_to_win32(){

   char * RUNDIR;
   RUNDIR=getenv("RUNMC");
   WSCstring  myv1=RUNDIR;
   myv1.addString( "/main/sys/HistogramTitels.runmc" );
   WSCstring  myv2=RUNDIR;
   myv2.addString( "/main/sys/HistogramTitelsWin32.runmc" );
   WSCstring win32replace="$(WSDIR)/sys/pixmaps/bi25.ico"; 

   int nn=0; 
   FILE *ls1 = fopen((char*)myv1,"r");

     char test0[60];
     char bb[81];
     char * tmp1;
     char * tmp2;
     WSCstring a1[500],a2[500],a3[500];
     WSCstring a1t,a2t; 
     WSCstring word[3];
   if (ls1  == NULL ){ cout << "Cannot find " <<  myv1 << endl; return; }

   while ( !feof(ls1) ) {
     fscanf(ls1,"%s",test0); fgets(bb,80,ls1);
     tmp1 = new char[strlen(test0)+1]; strcpy(tmp1,test0);
     tmp2 = new char[strlen(bb)+1]; strcpy(tmp2,bb);
    a1t=tmp1;
    a2t=tmp2;

    long words = a1t.getWords(","); //3 is returned
     
    for(int i=0; i < words; i++){
    word[i] = a1t.getWord(i,",");
//    long wordpos = a1t.getWordCharPos(i,",");
//  printf("word%d=%s\n",i,(char*)word); 
//  printf("   pos=%d\n",wordpos);
    }

     a1[nn]=word[0];
     a2[nn]=word[1];
     a3[nn]=a2t;
//     cout << a1[nn] << a2[nn] << a3[nn] << endl;
     nn++; 
    };
    fclose(ls1);


// create new file !
   ofstream myout((char*)myv2, ios::out | ios::trunc);
   if (!myout) { return; }
   for(int i=0; i < nn; i++){
   myout << win32replace << "," <<  a2[i] << a3[i];
   }
   myout.close(); 


 return;

}
