// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.lang.*;


public class RMCviewer{ 



    private HtmlBrowserDialog dlg;
    private String hstr;
   
    
        // Instance attributes used in this dialog
  public RMCviewer()  {

      hstr = ResourceLoader.getDisplay( "dlg.rmcviewer" );
      dlg = new HtmlBrowserDialog( Global.mainFrame, hstr, true );
      if ( Toolkit.getDefaultToolkit().getScreenSize().width > 800 )
      dlg.setSize( new Dimension( 600, 400 ) );
 
         
    String   fileName=SetEnv.RUNDIR+"/proj/user-comment.txt";  
    try {

     FileReader inF = new FileReader( fileName );
     BufferedReader in = new BufferedReader(inF);

         String article="";  
         String line;
         while ( (line = in.readLine()) != null)  {
           if (line.length()>0) article=article+line+"<br>"; 
         }
    in.close();

    dlg.setText(article);
    }
    catch (IOException e)
    {
      System.out.println("Error opening "+fileName);
    }
         
  
      dlg.show();

   
     }   
          
       

} // end class

