// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
// define your enviromental variable
package JRunMC;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.lang.*;



   public class  SetEnv {
     

// localisation
     public static Locale   locale;
     public static String   LANGU;

// file with the settings 
      public static String INIFILE="";

  // location of GUI
     public static  int  gui_x;
     public static  int  gui_y;
     public static  int  gui_h;
     public static  int  gui_w;
     public static  String OSsys;

// HTML styles
    public static String font_family="Lucida Sans";
    public static String font_name="Lucida Sans Demibold";
    public static String font_size="14";
    public static String font_face="bold";
    public static String font_style="normal";
    public static String background_color="#FFFFFC";
    public static String color="#000000";

// which tab is active? 
    public static int TabActive=0;


     public static String RUNDIR; // current directory
     public static String PXMDIR; // for windows
     public static String ROOTSYS; // ROOT

     public static String defa= "Default";
     
     public static String metal= "Metal";
     public static String metalClassName = "javax.swing.plaf.metal.MetalLookAndFeel";

     public static String motif = "Motif";
     public static String motifClassName =
            "com.sun.java.swing.plaf.motif.MotifLookAndFeel";

     public static String windows = "Windows";
     public static String windowsClassName =
            "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
   
     public static String liquid = "Liquid";
     public static String liquidClassName =
            "com.birosoft.liquid.LiquidLookAndFeel";

     public static String kunststoff = "Kunststoff";
     public static String kunststoffClassName =
            "com.incors.plaf.kunststoff.KunststoffLookAndFeel";

 
     public static int Style=0; // select style
     public static Font FontBold;
     public static Font FontPlain;    
     
       
     

    public static void init() { 

 // send default local
     LANGU="en";
     locale = new Locale(LANGU);
     Locale.setDefault(locale);

     String OS = System.getProperty("os.name").toLowerCase();

  if (OS.indexOf("windows") > -1 || OS.indexOf("nt") > -1) {
     OSsys="windows";
     INIFILE="jrunmc.ini";
  }  else {
     // linux/unix/BS-based/mac
     OSsys="unix/linux";
     INIFILE=".jrunmcrc";
    }

 
     FontBold= new Font("Lucida Sans", Font.BOLD, 14); 
     FontPlain= new Font("Lucida Sans", 0, 14);

/*
    String newline;
    newline = System.getProperty("user.dir");
   // System.out.println(newline);
    newline = System.getProperty("user.home");
  //  System.out.println(newline);
    newline = System.getProperty("os.arch");
  //  System.out.println(newline);
    newline = System.getProperty("os.name");
  //  System.out.println(newline);
    newline = System.getProperty("java.vm.version");
  //  System.out.println(newline);
    newline = System.getProperty("java.vm.name");
  //  System.out.println(newline);

 */
 
    // get $RUNMC variable, works for wll Java versions 
    try {
    Process p = Runtime.getRuntime().exec("bash"); // invoke shell
    PrintWriter out = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    out.println("echo $RUNMC"); // place commands here
    out.println("exit");
    out.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));
    // retrieve data from standard output stream
    String line;
    while ((line = inp.readLine()) != null)
    // System.out.println(line);
    if (line.length()>1) RUNDIR=line;
    } catch (Exception err) {
     err.printStackTrace();
     };
  

         
 // windows 
    try {
    Process p = Runtime.getRuntime().exec("bash"); // invoke shell 
    PrintWriter outw = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    outw.println("echo $RUNMCwin32"); // place commands here
    outw.println("exit");
    outw.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));
    String line;
    while ((line = inp.readLine()) != null)
    // line=line.trim();
    // System.out.println(line);
     if (line.length()>1) PXMDIR=line;
    } catch (Exception err) {
     err.printStackTrace();
     } 
    
// ROOT
    try {
    Process p = Runtime.getRuntime().exec("bash"); // invoke shell 
    PrintWriter outw = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    outw.println("echo $ROOTSYS"); // place commands here
    outw.println("exit");
    outw.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));
    String line;
    while ((line = inp.readLine()) != null)
    //line=line.trim();
     //System.out.println(line);
     if (line.length()>1) ROOTSYS=line;
    } catch (Exception err) {
     err.printStackTrace();
     }   
    
    
/*
     // show error      
    if ( RUNDIR.length()<2) {         
    JOptionPane dialog = new JOptionPane();
                  dialog.showMessageDialog(dialog, "$RUNMC directory is not defined",
                                         "Error", JOptionPane.ERROR_MESSAGE ); }
              
 */
    
     
//     System.out.println(RUNDIR);
//     System.out.println(PXMDIR);
//    System.out.println(ROOTSYS);


//      RUNDIR="/home/runmc";

    
     } 
    
    
    
     
     
   }
