// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC;

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.util.StringTokenizer;

 public class Tab1 extends JPanel {
     
  
    
     private JTable jMCinstalled;
     private MyTableModelInfo myModel;
     private JPanel jtop; 
     private Timer timerProc;  // to run 
     private int delay = 0;   // delay for 5 sec.
     private int period = 2000;  // repeat every sec.
     private static boolean ichanged = false;
     private static int istatus[];
     private static int istatus_old[];
     private static int oldrowlocation=0;
 
  //  SetIni  SetIni = new SetIni();
    
    public Tab1() {
    this.setPreferredSize(new java.awt.Dimension(500, 250));
    this.setMinimumSize(new java.awt.Dimension(50, 50)); 
  
     this.setLayout( new BorderLayout() );
     JScrollPane JScrollPane1 = new JScrollPane();
     JScrollPane1.setMinimumSize(new Dimension(10, 24));

      jtop=new JPanel();
      jtop.setPreferredSize(new java.awt.Dimension(500,45));
      jtop.setMinimumSize(new java.awt.Dimension(50, 45));
      this.add(jtop,java.awt.BorderLayout.NORTH);
 
  
/*     
   //  this.setBackground(Color.white);   
    
   
     JLabel about1 = new JLabel();
     about1.setText("Welcome to RunMC");                 
     about1.setPreferredSize(new java.awt.Dimension(400, 40));
     about1.setMinimumSize(new java.awt.Dimension(70, 10));
     about1.setFont(new java.awt.Font("Dialog", 1, 24));
     about1.setForeground( Color.blue );
     
     //about1.setFont(SetEnv.FontBold);
     this.add(about1);
*/
     
     JLabel about2 = new JLabel();
     about2.setPreferredSize(new java.awt.Dimension(500, 40));
     about2.setMinimumSize(new java.awt.Dimension(100, 10));
     if (SetEnv.RUNDIR.length()>2) { 
       about2.setText( SetEnv.RUNDIR ); 
     } else {
       about2.setForeground(new java.awt.Color(255, 0, 0));
       about2.setText("$RUNMC was not set - error");
     } 
     about2.setFont(SetEnv.FontBold);
     
     about2.setBorder(new TitledBorder(null,
                                   "Base directory:",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
          
     jtop.add(about2);

/*     
     
     JLabel about3 = new JLabel();
     about3.setPreferredSize(new java.awt.Dimension(400, 40));
     about3.setMinimumSize(new java.awt.Dimension(70, 10));
     if (SetEnv.ROOTSYS.length()>2) { 
       about3.setText("$ROOTSYS was set - looks OK"); 
     } else {
       about3.setForeground(new java.awt.Color(255, 0, 0));
       about3.setText("$ROOTSYS was not set - error");
     } 
     about3.setFont(SetEnv.FontBold);
     about3.setBorder(new TitledBorder(null,
                                   "Check installation of ROOT:",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
     this.add(about3);
 */    

    myModel = new MyTableModelInfo();
   jMCinstalled = new JTable(myModel);
   jMCinstalled.setRowHeight(20);
   myModel.addColumn(ResourceLoader.getDisplay("ui.mcinstalled"));
   myModel.addColumn(ResourceLoader.getDisplay("ui.mcalias"));
   myModel.addColumn(ResourceLoader.getDisplay("ui.mcstatus"));

     jMCinstalled.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     // channge size
          TableColumn column = null;



          column = jMCinstalled.getColumnModel().getColumn(0);
          column.setPreferredWidth(150);
          column.setMinWidth(50);
          column.setMaxWidth(600);

          column = jMCinstalled.getColumnModel().getColumn(1);
          column.setPreferredWidth(150);
          column.setMinWidth(50);
          column.setMaxWidth(600);

          column = jMCinstalled.getColumnModel().getColumn(2);
          column.setPreferredWidth(80);
          column.setMinWidth(30);
          column.setMaxWidth(120);

         for (int i=0; i<SetMC.available.size();  i++) {
         String smc=(String)SetMC.available.elementAt(i);
         String salias=(String)SetMC.available_alias.elementAt(i);
         String status=(String)SetMC.status.elementAt(i);

         myModel.addRow(
                new Object[]{new String(smc), new String(salias),  new String(status) });
         }

       JScrollPane1.getViewport().add(jMCinstalled);
       this.add(JScrollPane1,java.awt.BorderLayout.CENTER);


//   define timer for status checks 
     timerProc = new Timer(period, taskCheckProc);
     timerProc.setInitialDelay(delay);
     timerProc.setRepeats(true);
//     StartTimer();

     istatus = new int[SetMC.available.size()];
     istatus_old = new int[SetMC.available.size()];
     for (int i=0; i<SetMC.available.size(); i++) istatus[i]=0; 
     for (int i=0; i<SetMC.available.size(); i++) istatus_old[i]=0;

 }


// timer task
  ActionListener taskCheckProc = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent eProc) {


     
    for (int i=0; i<SetMC.available.size(); i++) istatus[i]=0;



    try {
//    System.out.println("read status");
    Process p = Runtime.getRuntime().exec("bash"); // invoke shell
    PrintWriter out = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    out.println("$RUNMC/main/runmc/show_process.sh"); // place commands here
    out.println("exit");
    out.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));

    String line;
    while ((line = inp.readLine()) != null) {
    if (line.length()>4) {

        for (int i=0; i<SetMC.available.size();  i++) {
        String smc="analmc."+(String)SetMC.available.elementAt(i);
          if (line.indexOf(smc)>0) istatus[i]=1; 
        }

     }
    }
    inp.close();


// check status
    ichanged=false;
    for (int i=0; i<SetMC.available.size(); i++) {
        if (istatus_old[i] !=istatus[i] ) ichanged=true;
    }



      if (ichanged) { // only if status has changed

       
      for (int i=0; i<SetMC.available.size();  i++) {
        // copy new status

        if (istatus_old[i] != istatus[i] && istatus[i] == 1) {
           myModel.moveRow(i, i, 0);
           String status="<html><font color=#ee0000><b>running</b></font></html>"; 
           myModel.setValueAt(new String(status), 0, 2);
           oldrowlocation=i;
        } 

// if not active put to old location  
       if (istatus_old[i] != istatus[i] && istatus[i] == 0) {
            String status="idle"; 
            myModel.moveRow(0, 0, oldrowlocation);
            myModel.setValueAt(new String(status), oldrowlocation, 2);
        }


        istatus_old[i]=istatus[i];

       
/*
        String smc=(String)SetMC.available.elementAt(i);
        String salias=(String)SetMC.available_alias.elementAt(i);
        String status=(String)SetMC.status.elementAt(i);
        if (istatus[i] ==  1) status="<html><font color=#ee0000><b>running</b></font></html>"; 
        myModel.setValueAt(new String(status), i, 2); 
        // move to the beginning 
//        if (istatus[i] ==  1) myModel.moveRow(i, i, 0); 
         System.out.println(status); 
*/

        }


      } // endif


    // retrieve data from standard output stream
    } catch (Exception err) {
     err.printStackTrace();
     };

    }; }; 



public void StartTimer() {
    timerProc.start();
 }   


public void StopTimer() {
    timerProc.stop();
 }






     
  } // end main class
