// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC;

// select MC
import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.ListCellRenderer.*;

 public class Tab2 extends JPanel {
     
  
    public JList MClist;
    public JList NTlist;
        
    
    
    public Tab2() {  
    this.setPreferredSize(new java.awt.Dimension(500, 250));
    this.setMinimumSize(new java.awt.Dimension(50, 50));    
    
      
   
    MClist = new JList( SetIni.MC );
    MClist.setCellRenderer( new CustomCellRenderer() );
    MClist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    MClist.setSelectedIndex(0);
    MClist.setVisibleRowCount(7);
    MClist.setFont(SetEnv.FontBold);
    JScrollPane listPane1 = new JScrollPane(MClist);
    listPane1.getViewport().setView(MClist);
    listPane1.setPreferredSize(new java.awt.Dimension(150, 170));
    listPane1.setMinimumSize(new java.awt.Dimension(40, 10));
    this.add(listPane1);
       
    
      
    NTlist = new JList( SetIni.NTUPLES );
    NTlist.setCellRenderer( new CustomCellRenderer() );
    NTlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    NTlist.setSelectedIndex(-1);
   // NTlist.setVisibleRowCount(7);
    NTlist.setFont(SetEnv.FontBold);
    JScrollPane listPane2 = new JScrollPane(NTlist); 
    listPane2.getViewport().setView(NTlist);
    listPane2.setPreferredSize(new java.awt.Dimension(150, 170));
    listPane2.setMinimumSize(new java.awt.Dimension(40, 10));
    this.add(listPane2);

 
    }   
    
// update this pannel with new settings
     public void setPan()  {

     if (SetIni.MCtype>=1) {
        NTlist.clearSelection();
        NTlist.repaint();
        int nn=SetIni.MCtype-1;
        MClist.setSelectedIndex(nn);
        }

     if (SetIni.MCtype<0) {
        MClist.clearSelection();
        MClist.repaint();
        int nn=0;
        if (SetIni.MCtype == -1) nn=0;
        if (SetIni.MCtype == -2) nn=1;
        NTlist.setSelectedIndex(nn);
        }

      }
       
        
      } // end main class
 
 
 
 class CustomCellRenderer
 extends  JLabel
 implements ListCellRenderer 
{
 private ImageIcon image[];
  
 final static ImageIcon longIcon = new ImageIcon("long.gif");
 final static ImageIcon shortIcon = new ImageIcon("short.gif");
  
  
 
 
 
 
 // change defaults for JList
 public CustomCellRenderer()
 {
  setOpaque(true);

 
  /*
  // Pre-load the graphics images to save time
  image = new ImageIcon[4];
  image[0] = new ImageIcon( "circles.gif" );
  image[1] = new ImageIcon( "bubbles.gif" );
  image[2] = new ImageIcon( "thatch.gif" );
  image[3] = new ImageIcon( "pinstripe.gif" );
 
 */
 }
  
  
 public Component getListCellRendererComponent(
   JList list, Object value, int index, 
   boolean isSelected, boolean cellHasFocus )
   
 
 {
  // Display the text for this item
  
   
   
  String s = value.toString();
         setText(s);
         setIcon((s.length() > 10) ? longIcon : shortIcon);
  
  
  // Draw the correct colors and font
  if( isSelected )
  {
   // Set the color and font for a selected item
   setBackground( Color.blue );
   setForeground( Color.white );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }
  else
  {
   // Set the color and font for an unselected item
   setBackground( Color.white );
   setForeground( Color.black );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }

  return this;
 }
}
 
 
 
 
 
 
 
