// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC;

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;


 public class Tab4 extends JPanel {
     
    public JCheckBox OutMC1;
    public JCheckBox OutMC2;
    public JCheckBox OutMC3;
    public JButton   bhisto; 
 
    public Tab4() {
      
    this.setPreferredSize(new java.awt.Dimension(500, 250));
    this.setMinimumSize(new java.awt.Dimension(50, 50));    
    
  
        
    OutMC1 = new JCheckBox("Histograms"); 
    OutMC1.setSelected(true); this.add(OutMC1); 
    OutMC1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
              if ( !OutMC1.isSelected()) SetIni.HistoOptions[9]=1;
              if (  OutMC1.isSelected())  SetIni.HistoOptions[9]=0;
              setMessage();
            //  T7.showSummaryOut2();
            }   });
 
         
    OutMC2 = new JCheckBox("HEPEVT ntuple"); 
    OutMC2.setSelected(false); this.add(OutMC2); 
    OutMC2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
              if ( !OutMC2.isSelected()) SetIni.HistoOptions[10]=1;
              if (  OutMC2.isSelected())  SetIni.HistoOptions[10]=0;
              setMessage(); 
           //   T7.showSummaryOut2();
            }   });
 

 
    OutMC3 = new JCheckBox("RunMC Ntuple"); 
    OutMC3.setSelected(false); this.add(OutMC3); 
    OutMC3.addMouseListener(new java.awt.event.MouseAdapter() {
       public void mousePressed(java.awt.event.MouseEvent evt) {
             if ( !OutMC3.isSelected()) SetIni.HistoOptions[11]=1;
             if (  OutMC3.isSelected())  SetIni.HistoOptions[11]=0;
             setMessage(); 
           //   T7.showSummaryOut2();
           }   });
   
  
    bhisto = new JButton("Histogram editor");
    bhisto.setToolTipText("To set histograms, click here");
    bhisto.setPreferredSize(new java.awt.Dimension(170, 25));
    bhisto.setActionCommand("disable");
    this.add(bhisto);    
      
    }
    

// update this pannel with new settings
   public void setPan()  {

   // output
     OutMC1.setSelected(false);
     OutMC2.setSelected(false);
     OutMC3.setSelected(false);
     if (SetIni.HistoOptions[9]  ==1) OutMC1.setSelected(true);
     if (SetIni.HistoOptions[10] ==1) OutMC2.setSelected(true);
     if (SetIni.HistoOptions[11] ==1) OutMC3.setSelected(true);


     }


// update this pannel with new settings
     private void setMessage()  {
     String f1=SetIni.MOutput+".root";
     String f2=SetIni.MOutput+".htup";
     String f3=SetIni.MOutput+".rtup";
     String f2a="-//-.htup";
     String f3a="-//-.rtup";
     String outs="";
     int n1=SetIni.HistoOptions[9];
     int n2=SetIni.HistoOptions[10];
     int n3=SetIni.HistoOptions[11];
     if (n1 == 1 && n2 ==0 && n3 == 0 ) outs=f1;
     if (n1 == 1 && n2 ==1 && n3 == 0 ) outs=f1+", "+f2a;
     if (n1 == 1 && n2 ==0 && n3 == 1 ) outs=f1+", "+f3a;
     if (n1 == 1 && n2 ==1 && n3 == 1 ) outs=f1+", "+f2a+", "+f3a;
     if (n1 == 0 && n2 ==0 && n3 == 0 ) outs="none";
     if (n1 == 0 && n2 ==1 && n3 == 0 ) outs=f2;
     if (n1 == 0 && n2 ==0 && n3 == 1 ) outs=f3;
     if (n1 == 0 && n2 ==1 && n3 == 1 ) outs=f2+", "+f3a;
  
     SetIni.ShowFout=outs;
     Global.mainFrame.ShowFileOut(outs);
     };


  
     
    } // end main class
