include ../Makefile.common

atest: libartest.a atest.o
	$(FC) $(FFLAGS) -o atest atest.o -L. -lartest $(PYTHIA6)

jtest: libartest.a jtest.o
	$(FC) $(FFLAGS) -o jtest jtest.o -L. -lartest $(PYTHIA6)

ptest: libartest.a ptest.o
	$(FC) $(FFLAGS) -o ptest ptest.o $(PYTHIA6) -L. -lartest $(PYTHIA6)

.F.f:
	$(CPP) -DPYTHIA6 $*.F > $*.f

libartest.a: $(OBJECTS)
	$(AR) $(ARFLAGS) $@ $?
	ranlib $@

clean:
	rm -f *.c *.o *~ core *.bak $(PPFILES)

realclean: clean
	rm -f atest jtest ltest ptest libartest.a libartestp5.a

