      SUBROUTINE CASCADE
      IMPLICIT None
c common for bases/spring 5.1
      Integer Mxdim
      PARAMETER (MXDIM = 50 )
      Double precision xlb,xub
      Integer ndimb,nwildb,ig,ncallb
      COMMON /BPARM1/ XLB(MXDIM),XUB(MXDIM),NDIMB,NWILDB,
     +   IG(MXDIM),NCALLB
      Double Precision acc1b,acc2b
      Integer itmx1b,itmx2b
      COMMON /BPARM2/ ACC1B,ACC2B,ITMX1B,ITMX2B
#include "caslujets.inc"
#include "casluco.inc"
#include "caspart.inc"
#include "caspara.inc"
#include "caspara1.inc"
#include "caseffic.inc"
#include "casgki.inc"
#include "casludat1.inc"
#include "casshwr.inc"
#include "casprkt.inc"
#include "casvalues.inc"
#include "casscal.inc"
#include "caspara5.inc"
#include "casmult.inc"
	Integer kf
	Common /cbran1/ kf
      REAL ACC1,ACC2
      Integer iint,ncb
      COMMON /INTEGR/ ACC1,ACC2,IINT,NCB
      Integer ndim
      COMMON/INTDIM/ NDIM
      REAL ANS,ERROR
      REAL PYPAR,PYVAR
      Integer IPY
      COMMON /MYPARA/ IPY(80),PYPAR(80),PYVAR(80)
      Integer Ndimc
      COMMON /DIMEN/ NDIMC
      double Precision XD(20)
      Double Precision XGR(20)
      CHARACTER CHIN*100
      CHARACTER * 16 CNAM
      CHARACTER * 7 CINT
      CHARACTER*8 VERSQQ
      Integer Lerr
      COMMON/ERR/LERR(100)
      Integer IGENFL,IMEPHI
      COMMON/GENWEI/IGENFL,IMEPHI
      Integer IGLU
	Common/CAGLUON/Iglu
      REAL SNGL
      double precision DFUN,FXN1,FXNB
      EXTERNAL DFUN,FXN1,FXNB
      Integer I,J,KPCH,KPAO,IT1,IT2
      Double Precision SQRTS,DDUM,CTIME
      Double Precision DOT
      VERSQQ = ' 1.20/07'
      IGENFL = 0
      DO 10  I=1,100
   10 LERR(I) = 0
      ERROR = 0.0
      CHIN='PARU(11)=0.010;'
      CALL PYGIVE(CHIN)
      ALPH=7.299D-3
      ALPHS=0.3D0
      PI=4.D0*DATAN(1.D0)
      IWEI = 0
C...  GIVE ELECTRON FOUR VECTOR
      K(1,1)=21
      K(1,2)=KE
      P(1,1) = 0.0D0
      P(1,2) = 0.0D0
      P(1,3) = DBLE(PLEPIN)
      P(1,5) = PYMASS(KE)
      P(1,4) = DSQRT(P(1,1)**2+P(1,2)**2+P(1,3)**2+P(1,5)**2)
C...  GIVE PROTON FOUR VECTOR
      K(2,1) = 21
      K(2,2) = KP
      P(2,1) = 0.0D0
      P(2,2) = 0.0D0
      P(2,3) = DBLE(PPIN)
      P(2,5) = PYMASS(KP)
      P(2,4) = DSQRT(P(2,1)**2+P(2,2)**2+P(2,3)**2+P(2,5)**2)
      N=2
      CALL PYLIST(1)
C... CALCULATE CMS ENERGY
      DO 20 I=1,4
         CM(I) =P(1,I)+P(2,I)
   20 CONTINUE

C BOOST TO EP CMS
      CALL PYROBO(0,N,0.D0,0.D0,-CM(1)/CM(4),-CM(2)/CM(4),-CM(3)/CM(4))
      DO 30 I=1,2
         DO 30 J=1,5
            PBEAM(I,J)=P(I,J)
   30 KBEAM(I,J)=K(I,J)
      KINT(1,2) = 22
      KINT(2,2)=2212
      KEB = KPH
      SSS = DOT(CM,CM)
      SQRTS=DSQRT(SSS)
      IF(IPRO.EQ.10.OR.IPRO.EQ.11.OR.IPRO.EQ.2.OR.IPRO.eq.102) THEN
      ELSE
         WRITE(6,*) ' wrong subprocess selected ', IPRO
         WRITE(6,*) ' PROGRAM STOPPED '
         STOP
      ENDIF
      CALL PYNAME(KINT(2,2),CNAM)
      CINT = CNAM(1:7)
      KPCH = 213
      CALL PYNAME(KPCH,CNAM)
      WRITE(6,10000)

      WRITE(6,10100)

      WRITE(6,10200)

      WRITE(6,10300) VERSQQ
	
	kf = 2212
	
      if(Iabs(K(1,2)).eq.2212) then
c proton proton
         write(6,*) '*       proton proton version selected            '
     +   //'  *'
         KEB=21
	   IRES(1)=1
	   IRES(2)=1
         IF(IPRO.EQ.10) WRITE(6,11300)
         IF(IPRO.EQ.11) THEN
            WRITE(6,11700)
            WRITE(6,11800) MAX(4,IHFLA)
            KPA=4
         ENDIF
         IF(IPRO.EQ.102) WRITE(6,11302)
	   write(6,11801) Mult
      elseif(Iabs(K(2,2)).eq.22.or.
     & (Iabs(K(1,2)).eq.11.and.Iabs(K(2,2)).eq.11)) then
	if(Iabs(K(2,2)).eq.22) then 
c gamma gamma 
         write(6,*) '*     gamma gamma version selected                '
     +   //'  *'
         else
         write(6,*) '*     e+ e-   version selected                    '
     +   //'  *'
         endif
         KEB=22
	   kf=keb
         KINT(1,2) = 22
         KINT(2,2) = 22 
         IF(IPRO.EQ.10) WRITE(6,11301)
         IF(IPRO.EQ.11) THEN
            WRITE(6,11701)
            WRITE(6,11800) MAX(4,IHFLA)
            KPA=4
         ENDIF
         IF(IPRO.EQ.102) WRITE(6,11302)
        write(6,*) '*     beam 1:  direct/resolved (0/1): ',Ires(1),
     +   '            *'
        write(6,*) '*     beam 2:  direct/resolved (0/1): ',Ires(2),
     +   '            *'
	   
      else
	   IRES(2)=1
         IF(INTER.EQ.0) WRITE(6,10400)
         IF(INTER.EQ.2) WRITE(6,10500)
         IF(IPRO.EQ.10) THEN
            IF(NFLAV.LE.3) THEN
               IF(INTER.EQ.0) WRITE(6,10600) CINT
               IF(INTER.EQ.2) WRITE(6,10700) CINT
            ELSE
               IF(INTER.EQ.0) WRITE(6,10800) CINT,NFLAV
               IF(INTER.EQ.2) WRITE(6,10900) CINT,NFLAV
            ENDIF
         ENDIF
         IF(IPRO.EQ.2) THEN
            IF(INTER.EQ.0) WRITE(6,11000) CINT
            IF(INTER.EQ.2) WRITE(6,11100) CINT
         ENDIF
         IF(IPRO.EQ.10) WRITE(6,11200)

         IF(ISEMIH.EQ.1) THEN
            IF(IPRO.EQ.2) then
               write(6,11500)
            else
               write(6,11400)
            endif
         ENDIF
         IF(IPRO.EQ.11) THEN
            IF(INTER.EQ.0) THEN
               WRITE(6,11600) CINT
               WRITE(6,11800) MAX(4,IHFLA)
            ENDIF
            IF(INTER.EQ.2) WRITE(6,11900) CINT
            KPA=4
         ENDIF
         IF(IPRO.EQ.11) WRITE(6,12000)

         IHF = 0
         IF(THEMA.NE.180.0D0) THEN
            WRITE(6,12100) THEMA

         ELSE
            WRITE(6,*) '*  no cut on max angle of scattered electron   '
     +      //'     *'
         ENDIF
         IF(THEMI.NE.0.0D0) THEN
            WRITE(6,12200) THEMI

         ELSE
            WRITE(6,*) '*  no cut on min angle of scattered electron   '
     +      //'     *'
         ENDIF
         IF(QMI.GT.0.0) THEN
            WRITE(6,12300) QMI

         ELSE
            WRITE(6,*) '*  Q^2 _min according to kinematics            '
     +      //'     *'
         ENDIF
         IF(QMA.LT.10D8) THEN
            WRITE(6,12400) QMA

         ELSE
            WRITE(6,*) '*  Q^2 _max according to kinematics            '
     +      //'     *'
         ENDIF
         IF(YMI.GT.0.0) THEN
            WRITE(6,12500) YMI

         ELSE
            WRITE(6,*) '*  y_min according to kinematics               '
     +      //'     *'
         ENDIF
         IF(YMA.LT.1.0) THEN
            WRITE(6,12600) YMA

         ELSE
            WRITE(6,*) '*  y_max according to kinematics               '
     +      //'     *'
         ENDIF
      endif
      IF(PT2CUT(IPRO).GT.0D0) then
         PT2CUT(10) = PT2CUT(IPRO)
         PT2CUT(11) = PT2CUT(10)
      Endif
      IF(PT2CUT(IPRO).GT.0D0) write(6,17100) DSQRT(PT2CUT(IPRO)),IPRO
      IF(PT2CUT(IPRO).GT.0D0) then
         PT2CUT(10) = PT2CUT(IPRO)
         PT2CUT(11) = PT2CUT(10)
         write(6,11888)
      Endif
      IPY(8) = NFLAV

      WRITE(6,*) '*****************************************************'
      IF(IFPS.EQ.0) THEN
         IPY(13) = 0
         IPY(14) = 0
      ENDIF
      IF(IFPS.NE.0) THEN
         WRITE(6,*) '##################################################'
     +   //'###'
         WRITE(6,*) '#     parton shower selection:                    '
     +   //'  #'
         IF(IFPS.EQ.0) THEN
            IPY(13) = 0
            IPY(14) = 0
         ELSEIF(IFPS.EQ.1) THEN
            IPY(13) = 0
            IPY(14) = 1		
            if(iglu.eq.1.or.iglu.ge.6) then
		   else
               IPY(14) = 0
               WRITE(6,*) '############################################'
     +         //'#########'
               WRITE(6,*) '#     no initial state PS possible for IGLU>'
     +         //'1       #'
               WRITE(6,*) '#        initial state PS switched off      '
     +         //'        #'
               WRITE(6,*) '#     see manual.                           '
     +         //'        #'
            endif
         ELSEIF(IFPS.EQ.2) THEN
            IPY(13) = 1
            IPY(14) = 0
         ELSEIF(IFPS.EQ.3) THEN
            IPY(13) = 1
            IPY(14) = 1
            if(ires(1).eq.1.and.iabs(K(1,2)).eq.11) then
               IPY(14) = 0
               WRITE(6,*) '############################################'
     +         //'#########'
               WRITE(6,*) '#     no initial state PS possible for resol'
     +         //'ved     #'
               WRITE(6,*) '#     initial state PS switched off         '
     +         //'        #'
               WRITE(6,*) '#     see manual.                           '
     +         //'        #'
            endif
            if(iglu.eq.1.or.iglu.ge.6) then
		   else
               IPY(14) = 0
               WRITE(6,*) '############################################'
     +         //'#########'
               WRITE(6,*) '#     no initial state PS possible for IGLU>'
     +         //'1 or 6    #'
               WRITE(6,*) '#        initial state PS switched off      '
     +         //'        #'
               WRITE(6,*) '#     see manual.                           '
     +         //'        #'
            endif
         ENDIF
         if(IPY(14).EQ.1.and.Iccfm.eq.1) Then
            WRITE(6,*) '#     CCFM inital state parton showers '
     +      //'including    #'
            WRITE(6,*) '#     angular ordering                         '
     +      //'     #'
         endif
         if(IPY(14).EQ.1.and.Iccfm.eq.0) Then
            WRITE(6,*) '#     DGLAP inital state parton showers '
     +      //'including   #'
            WRITE(6,*) '#     angular ordering                         '
     +      //'     #'
         endif
         if(itimshr.eq.1)
     +   WRITE(6,*) '#     timelike inital state partons may shower    '
     +   //'  #'
         if(itimshr.eq.0)
     +   WRITE(6,*) '#     no timelike inital state partons            '
     +   //'  #'
         IF(IPY(13).EQ.1) WRITE(6,*) '#     final state parton shower  '
     +   //'                   #'
         WRITE(6,*) '##################################################'
     +   //'###'
         WRITE(6,*) ' '
      ENDIF
	write(6,*)  '##################################################'
	write(6,*)  '#           proton remnant parameters            #'
	write(6,12701) IRspl
12701	format(' #    energy sharing IREM = ',I2,'                    #')
	write(6,*)  '##################################################'
      WRITE(6,12700) SQRTS
c      IF(IRUNAEM.EQ.0) THEN
c         WRITE(6,*) ' alpha_em fixed; alpha_em = ',ALPH
c      ELSE
c         WRITE(6,*) ' running alpha_em selected '
c      ENDIF
      IF(IRUNA.EQ.0) THEN
         MSTU(111) = 0
         PARU(111) = ALPHS
         WRITE(6,*) ' alpha_s fixed; alpha_s = ',ALPHS
      ENDIF
      IF(IQ2.EQ.1) WRITE(6,*) ' scale for alpha_s: 4*m_q**2 '
      IF(IQ2.EQ.2) WRITE(6,*) ' scale for alpha_s: shat '
      IF(IQ2.EQ.3) WRITE(6,*) ' scale for alpha_s: m_q**2 + p_t **'
     +//'2 '
      IF(IQ2.EQ.4) WRITE(6,*) ' scale for alpha_s: Q2 '
      IF(IQ2.EQ.5) WRITE(6,*) ' scale for alpha_s: Q2 + p_t **2'
      IF(IQ2.EQ.6) WRITE(6,*) ' scale for alpha_s: kt**2 '
      IF(IQ2.EQ.7) WRITE(6,*) ' scale for alpha_s:'
     +//'two*(sL*rt*ru)/((sL*rt*ru)**2+rt**2+ru**2)'

      WRITE(6,*) ' scale or alpha_s is multiplied by: ',SCALFA
c      WRITE(6,13300) PARU(112),MSTU(112)
c      PYPAR(21) = PARU(112)



      KPAO = KPA


      IF(IPRO.EQ.10.OR.IPRO.EQ.11) NDIM=8
      NDIMC = 9999
   40 CALL dcasrnv(XGR,20)
      DO 50 I=1,20
   50 XD(I)=XGR(I)
      DDUM=DFUN(20,XD)
*         WRITE(6,*) ' NDIM dynamically calculated ',NDIM,NDIMC
      IF(NDIMC.GT.20) goto 40
      NDIM = NDIMC
      NIN=0
      NOUT=0

********************************************************************
*     Initialization of BASES/SPRING V5.1
********************************************************************
*===> Initialization of BASES by calling BSINIT

      CALL BSINIT
      NDIMB=NDIM
      NWILDB = NDIM
      NCALLB = NCB
      ITMX1B = 30
      ACC1B = DBLE(ACC1)
      ITMX2B = 100
      ACC2B = DBLE(ACC2)
      DO 60 I=1,NDIMB
         IG(I) = 1
         XLB(I)=1.0D-12
   60 XUB(I)=1.D0
********************************************************************
*     Nimerical Integration by BASES V5.1
********************************************************************

      CALL BASES( FXNB, AVGI, SD, CTIME, IT1, IT2 )

      ANS = SNGL(AVGI)
      ERROR = SNGL(SD)
      SD=DBLE(ERROR)
      AVGI=DBLE(ANS)



      KPA = KPAO
      RETURN

10000 FORMAT(' *****************************************************')
10100 FORMAT(' *                                                   *')
10200 FORMAT(' *     You are using the CASCADE MC generator        *')
10300 FORMAT(' *           version  ',A8,'                       *')
10400 FORMAT(' *    neutral current interaction selected           *')
10500 FORMAT(' *    charged current interaction selected           *')
10600 FORMAT(' *  gamma + gluon_',A6,' --> q q_bar(light quarks)   *')
10700 FORMAT(' *      W + gluon_',A6,' --> q q_bar(light quarks)   *')
10800 FORMAT(' *  gamma + gluon_',A6,' --> q q_bar max flav =',I2,
     +'    *')
10900 FORMAT(' *      W + gluon_',A6,' --> q q_bar max flav =',I2,
     +'    *')
11000 FORMAT(' *  gamma + gluon_',A6,' --> J/psi gluon',
     +'             *')
11100 FORMAT(' *      W + gluon_',A6,' --> q q_bar max flav =',I2,
     +'    *')
11200 FORMAT(' *  EPA + gamma* gluon --> q q_bar  used             *')
11300 FORMAT(' *  gluon* gluon* --> q q_bar  used                  *')
11301 FORMAT(' *   gamma gamma --> q q_bar  used                   *')
11302 FORMAT(' *       g g --> h0                                  *')
11400 FORMAT(' *  semihard approach for BGF Catani et al           *')
11500 FORMAT(' *  semihard approach for BGF Zotov et al            *')
11600 FORMAT(' *     gamma + gluon_',A4,
     +   ' --> Q Q_bar                *')
11700 FORMAT(' *     gluon* + gluon*',
     +   ' --> Q Q_bar                   *')
11701 FORMAT(' *     gamma  + gamma',
     +   ' --> Q Q_bar                    *')
11800 FORMAT(' *     heavy flavor produced is :',
     +    I3,'                 *')
11801	   format(' *       multiple scattering selected: ',I2,
     +'            *')
11900 FORMAT(' *      W + gluon_',A4,
     +   ' --> c c_bar                   *')
12000 FORMAT(' *  EPA + gamma gluon --> Q Q_bar (massive)   used   *')
12100 FORMAT(' *  scattered electron theta_max = ',F7.3,'           *')
12200 FORMAT(' *  scattered electron theta_min = ',F7.3,'            *')
12300 FORMAT(' *  Q^2 _min = ',F8.3,'                              *')
12400 FORMAT(' *  Q^2 _max = ',F8.3,'                              *')
12500 FORMAT(' *  y _min = ',F7.3,'                                 *')
12600 FORMAT(' *  y _max = ',F7.3,'                                 *')
12700 FORMAT('  cm energy   ',F10.3,' GeV')
17100 FORMAT(' *  cut on p_t = ',f5.2,' for IPRO = ',I5,
     +       '              *')
11888 FORMAT(' *  cut on pt applied to process 10 and 11           *')
      END
