// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
// main RunMC file
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <unistd.h>
#include <sys/stat.h>
using namespace std;

// main program
int  main(int argc, char **argv) {


// file will be loaded by ep_loadfile.cpp function
// then link will be removed by the same function 

//  struct stat buf;
//  int defaultlink = stat ( ".runmc.mc", &buf );
//  if ( defaultlink  == 0) { remove(".runmc.mc"); };

// remove just in case old file/link 
  remove(".runmc.mc");
  remove(".analmc.ln");
  remove(".analmc.log");

  if ( argc  > 1 ) {  
  cout << "Loading project file " << argv[1] << endl; 

  if (symlink(argv[1],".runmc.mc") == -1 ) {
     perror("symlink"); 
     exit (1); 
   } 

   }
 

  int irun=system( "runmc_gui" );
  if (irun != 0) return 1;

//  remove(".runmc.mc");
//  this link will be removed in ep_loadfile.cpp, when it is processed 


// clean old pipe files
  irun=system( "$RUNMC/main/runmc/clean_pipe.sh" );
  if (irun != 0) return 1;
 

 return 0;
 }
