// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <TROOT.h>
#include "CLHEP/config/CLHEP.h"
#include "CLHEP/config/iostream.h"
#include "CLHEP/config/iomanip.h"
#include "CLHEP/HepPDT/ParticleID.hh"
using namespace std;

Int_t charge3(Int_t id) {
// get 3-charge 

//    int it,sid,js,ls;
    int  nr, nx;
    int chg, extra;

       HepPDT::ParticleID pid( id );
        nx = pid.digit(HepPDT::n);
        nr = pid.digit(HepPDT::nr);
        extra = pid.extraBits();
//        cout << endl;
//        cout << setw(18) << id << ": " << nx << " " << nr
//                     << " " << pid.digit(HepPDT::nl)
//                     << " " << pid.digit(HepPDT::nq1) << " "
//                     << pid.digit(HepPDT::nq2) << " " << pid.digit(HepPDT::nq3)
//                     << " " <<  pid.digit(HepPDT::nj)
//                     << " extra bits " << extra << endl;


//        js = pid.jSpin();
//        HepPDT::Quarks cqks = pid.quarks( );
//        ls = pid.lSpin();
//        sid = pid.fundamentalID();
 
       chg = (Int_t)pid.threeCharge();

//        cout << setw(18) << id << " 3 charge "  << chg <<  endl;
 

        return chg;

   }
